local mod = ...



-- Assets
-------------------------------------------------------------------------------------
mod:registerAssetId("models/BriningWorkplace.fbx/Prefab/Picklery", "PREFAB_PICKLERY")




-- Resource: Brined Fish
-------------------------------------------------------------------------------------
mod:registerAssetId("icons/brined_fish.png", "ICON_BRINED_FISH", "ATLAS_CELL")
mod:registerEnumValue( "RESOURCE_TYPE", "RESOURCE_TYPE_FISH_BRINED" )

mod:register({
	DataType = "RESOURCE",
	Id = "RESOURCE_BRINED_FISH",
	ResourceName = "RESOURCE_BRINED_FISH_NAME",
	Icon = "ICON_BRINED_FISH",
	ResourceTypeList = { "RESOURCE_TYPE_FISH_BRINED", "GRANARY", "FOOD", "FOOD_SELLABLE" },
	IsTradable = true,
	ResourceLayoutType = "CRATES",
	DisplayInInventory = true,
	VillagerBuyingPrice = { Resource = "GOLD", Quantity = 4 }
})



mod:override({
  Id = "FISH",
  IsTradable = false
})


-- mod:override({
	-- Id = "NEED_FOOD",
	-- NeedTypeList = {
		-- Action = "APPEND",
		-- "RESOURCE_TYPE_FISH_BRINED"
	-- }
-- })



-- Override Vanilla Market
------------------------------------------------------------------------------------
-- mod:override({
  -- Id = "BUILDING_FUNCTION_FOOD_MARKET",
	-- TypeList = { 
	-- Action = "APPEND",
	 -- "RESOURCE_TYPE_FISH_BRINED" 
  -- }
-- })



-- If Market Carts is loaded, change fish to brined fish
if (foundation.isModLoaded("16b72059-8e2b-4e58-8d1f-82a0a03f2cb3")) then

mod:override ({
    Id = "BUILDING_FUNCTION_MARKETCART_FISH",
	TypeList = { "RESOURCE_TYPE_FISH_BRINED" },
	InputInventoryCapacity = {
		{ Resource = "RESOURCE_BRINED_FISH", Quantity = 50 },
	},
    ResourceListNeeded = {
		{ Resource = "RESOURCE_BRINED_FISH", Quantity = 10 },
	},
	ResourceProduced = {
		{ Resource = "RESOURCE_BRINED_FISH", Quantity = 10 },
	}
})

end



-- Monument: Brined Foods
-------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING", 
	Id = "BUILDING_PICKLERY",
	Name = "BUILDING_PICKLERY_NAME",
	Description = "BUILDING_PICKLERY_DESC",
	BuildingType = "FOOD_PRODUCTION",
	AssetCoreBuildingPart = "BUILDING_PART_MONUMENT_POLE",
	IsEditable = true,
	BuildingPartSetList = {
		{
			Name = "BUILDING_SET_PICKLERY_NAME",
			BuildingPartList = { 
				"PICKLERY_PART",
			}
		},		
    }
})



-- Building Part: Picklery
-------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "PICKLERY_PART",
	Name = "PICKLERY_PART_NAME",
	Description = "PICKLERY_PART_DESC",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_PICKLERY"
	},
	ConstructionVisual = "CV_PICKLERY",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {6.5, 6.5}, {-1.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
			},
		}
	},
	AssetBuildingFunction = "BUILDING_FUNCTION_PICKLERY_PART",
	Cost = {
		BuildRightTaxes = {	{ Resource = "GOLD", Quantity = 1 } },
		UpkeepCost = { { Resource = "GOLD", Quantity = 3 } },
		RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 10 },
			{ Resource = "PLANK", Quantity = 10 },
			{ Resource = "STONE", Quantity = 5 },
		}
	}
})



-- Building Function: Picklery
-------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_PICKLERY_PART",
    Name = "BUILDING_FUNCTION_PICKLERY_PART_NAME",
	-- IsPrivate = false,
    WorkerCapacity = 2,
    RelatedJob = { 
        Job = "JOB_PICKLER", 
        Behavior = "BEHAVIOR_WORK"
    },
	-- TypeList = { "RESOURCE_TYPE_FISH_BRINED" },
	-- IsOverrideCapacity = true,
	-- CapacityPerSlot = 50,
	InputInventoryCapacity = {
			{ Resource = "WOOD", Quantity = 30 },
			{ Resource = "BV1_BRINE", Quantity = 30 },
			{ Resource = "FISH", Quantity = 30 },
    },
    -- UpkeepPerCapacity = {
		-- { Resource = "GOLD_COINS", Quantity = 3 },
    -- },
	ResourceListNeeded = {
		{ Resource = "WOOD", Quantity = 1 },
		{ Resource = "BV1_BRINE", Quantity = 1 },
		{ Resource = "FISH", Quantity = 1 },
	},
    ResourceProduced = {
		{ Resource = "RESOURCE_BRINED_FISH", Quantity = 1 }
	}
})



-- Job: Pickler -------------------------------------------------------------------------------------
mod:register({
	DataType = "JOB",
	Id = "JOB_PICKLER",
	JobName = "JOB_PICKLER_NAME",
	JobDescription = "JOB_PICKLER_DESC",
	IsLockedByDefault = false,
	DefaultBehavior = "BEHAVIOR_WORK",
    ProductionDelay = 15, -- default 30
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
		DataType = "CHARACTER_SETUP",
		IdleAnimation = "GATHER"
	}
})

mod:override({
    Id = "NEWCOMER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_PICKLER"
    }
})

mod:override({
    Id = "SERF",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_PICKLER"
    }
})



-- Paths: 
-------------------------------------------------------------------------------------
mod:registerAssetId("models/BriningWorkplace.fbx/Prefab/Picklery/PATH_A_1", "PICKLERY_PATHA1")
mod:registerAssetId("models/BriningWorkplace.fbx/Prefab/Picklery/PATH_B_1", "PICKLERY_PATHB1")

mod:registerPrefabComponent("models/BriningWorkplace.fbx/Prefab/Picklery", {
    DataType = "COMP_BUILDING_PART",
    PathList = {
        {
            PathType = BUILDING_PATH_TYPE.DEFAULT,
            WayPointList = { "PICKLERY_PATHA1" }
        },
		{
            PathType = BUILDING_PATH_TYPE.DEFAULT,
            WayPointList = { "PICKLERY_PATHB1" }
        },
    }
})



-- Particle Effects: 
-- -----------------------------------------------------------------------------------
mod:registerAssetId("models/BriningWorkplace.fbx/Prefab/Picklery/VapourEmitterA", "VAPOUR_EMITTERA_PREFAB")

mod:registerPrefabComponent("models/BriningWorkplace.fbx/Prefab/Picklery/VapourEmitterA", {
	DataType = "COMP_PARTICLE_EMITTER_TOGGLE",
	Enabled = false
})

mod:registerPrefabComponent("models/BriningWorkplace.fbx/Prefab/Picklery/VapourEmitterA", {
	DataType = "COMP_PARTICLE_EMITTER",
	ParticleSystem = "PARTICLE_SYSTEM_SAWMILL_SMOKE",
	IsPlaying = false,
	IsEmitting = false
})



mod:registerAssetId("models/BriningWorkplace.fbx/Prefab/Picklery/FireEmitterA", "FIRE_EMITTERA_PREFAB")

mod:registerPrefabComponent("models/BriningWorkplace.fbx/Prefab/Picklery/FireEmitterA", {
	DataType = "COMP_PARTICLE_EMITTER_TOGGLE",
	Enabled = false
})
mod:registerPrefabComponent("models/BriningWorkplace.fbx/Prefab/Picklery/FireEmitterA", {
	DataType = "COMP_PARTICLE_EMITTER",
	ParticleSystem = "PARTICLE_SYSTEM_BLACKSMITH_FIRE",
	IsPlaying = false,
	IsEmitting = false
})


mod:registerPrefabComponent("models/BriningWorkplace.fbx/Prefab/Picklery", {
	DataType = "COMP_BUILDING_PART",
	FeedbackComponentListToActivate = {
		{
			"VAPOUR_EMITTERA_PREFAB", "COMP_PARTICLE_EMITTER_TOGGLE"
		},
		{
			"FIRE_EMITTERA_PREFAB", "COMP_PARTICLE_EMITTER_TOGGLE"
		},
	}
})



-- Grounding
-----------------------------------------------------------------------------------
mod:registerPrefabComponent("models/BriningWorkplace.fbx/Prefab/Picklery/GBasket.002", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/BriningWorkplace.fbx/Prefab/Picklery/GBasket.003", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/BriningWorkplace.fbx/Prefab/Picklery/GBasket.005", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/BriningWorkplace.fbx/Prefab/Picklery/GBasket.006", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/BriningWorkplace.fbx/Prefab/Picklery/Gpit.003", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/BriningWorkplace.fbx/Prefab/Picklery/Gpot.010", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/BriningWorkplace.fbx/Prefab/Picklery/Gpot.012", {DataType = "COMP_GROUNDED"})


-- Construction Visual
-----------------------------------------------------------------------------------
mod:registerAssetId("models/BriningWorkplace.fbx/Prefab/CVPicklery", "CV_PICKLERY")



